# Class ResourceMapping

java.lang.Object
org.eclipse.core.runtime.PlatformObject
org.eclipse.core.resources.mapping.ResourceMapping

All Implemented Interfaces:
  `IAdaptable`

Direct Known Subclasses:
  `AbstractRefactoringDescriptorResourceMapping, AbstractRefactoringHistoryResourceMapping, CompositeResourceMapping`

public abstract class ResourceMapping extends PlatformObject
A resource mapping supports the transformation of an application model object into its underlying file system resources. It provides the bridge between a logical element and the physical resource(s) into which it is stored but does not provide more comprehensive model access or manipulations.

Mappings provide two means of model traversal. The `accept(ResourceMappingContext, IResourceVisitor, IProgressMonitor)` method can be used to visit the resources that constitute the model object. Alternatively, a set or traversals can be obtained by calling `getTraversals(ResourceMappingContext, IProgressMonitor)`. A traversal contains a set of resources and a depth. This allows clients (such a repository providers) to do optimal traversals of the resources w.r.t. the operation that is being performed on the model object.

This class may be subclassed by clients.

Since:
  3.2
See Also:
  - `IResource`
  - `ResourceTraversal`

## Constructor Summary

Constructors
Constructor
Description
`ResourceMapping()`

## Method Summary

Modifier and Type
Method
Description
`void`
`accept(ResourceMappingContext context, IResourceVisitor visitor, IProgressMonitor monitor)`
Accepts the given visitor for all existing resources in this mapping.
`boolean`
`contains(ResourceMapping mapping)`
Return whether this resource mapping contains all the resources of the given mapping.
`boolean`
`equals(Object obj)`
Override equals to compare the model objects of the mapping in order to determine equality.
`IMarker[]`
`findMarkers(String type, boolean includeSubtypes, IProgressMonitor monitor)`
Returns all markers of the specified type on the resources in this mapping.
`abstract Object`
`getModelObject()`
Returns the application model element associated with this resource mapping.
`final ModelProvider`
`getModelProvider()`
Return the model provider for the model object of this resource mapping.
`abstract String`
`getModelProviderId()`
Returns the id of the model provider that generated this resource mapping.
`abstract IProject[]`
`getProjects()`
Returns the projects that contain the resources that constitute this application model.
`abstract ResourceTraversal[]`
`getTraversals(ResourceMappingContext context, IProgressMonitor monitor)`
Returns one or more traversals that can be used to access all the physical resources that constitute the logical resource.
`int`
`hashCode()`
Override hashCode to use the model object.

### Methods inherited from class PlatformObject

`getAdapter`

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ResourceMapping

public ResourceMapping()

## Method Details

### accept

public void accept(ResourceMappingContext context, IResourceVisitor visitor, IProgressMonitor monitor) throws CoreException
Accepts the given visitor for all existing resources in this mapping. The visitor's `IResourceVisitor.visit(IResource)` method is called for each accessible resource in this mapping.

Parameters:
  `context` - the traversal context
  `visitor` - the visitor
  `monitor` - a progress monitor, or `null` if progress reporting is not desired
Throws:
  `CoreException` - if this method fails. Reasons include:
  - The visitor failed with this exception.
  - The traversals for this mapping could not be obtained.

### contains

public boolean contains(ResourceMapping mapping)
Return whether this resource mapping contains all the resources of the given mapping.

This method always returns `false` when the given resource mapping's model provider id does not match that the of the receiver.

Parameters:
  `mapping` - the given resource mapping
Returns:
  `true` if this mapping contains all the resources of the given mapping, and `false` otherwise.

### equals

public boolean equals(Object obj)
Override equals to compare the model objects of the mapping in order to determine equality.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - the object to compare
Returns:
  `true` if the receiver is equal to the given object, and `false` otherwise.

### findMarkers

public IMarker[] findMarkers(String type, boolean includeSubtypes, IProgressMonitor monitor) throws CoreException
Returns all markers of the specified type on the resources in this mapping. If `includeSubtypes` is `false`, only markers whose type exactly matches the given type are returned. Returns an empty array if there are no matching markers.

Parameters:
  `type` - the type of marker to consider, or `null` to indicate all types
  `includeSubtypes` - whether or not to consider sub-types of the given type
  `monitor` - a progress monitor, or `null` if progress reporting is not desired
Returns:
  an array of markers
Throws:
  `CoreException` - if this method fails.

### getModelObject

public abstract Object getModelObject()
Returns the application model element associated with this resource mapping.

Returns:
  the application model element associated with this resource mapping.

### getModelProvider

public final ModelProvider getModelProvider()
Return the model provider for the model object of this resource mapping. The model provider is obtained using the id returned from `getModelProviderId()`.

Returns:
  the model provider

### getModelProviderId

public abstract String getModelProviderId()
Returns the id of the model provider that generated this resource mapping.

Returns:
  the model provider id

### getProjects

public abstract IProject[] getProjects()
Returns the projects that contain the resources that constitute this application model.

Returns:
  the projects

### getTraversals

public abstract ResourceTraversal[] getTraversals(ResourceMappingContext context, IProgressMonitor monitor) throws CoreException
Returns one or more traversals that can be used to access all the physical resources that constitute the logical resource. A traversal is simply a set of resources and the depth to which they are to be traversed. This method returns an array of traversals in order to provide flexibility in describing the traversals that constitute a model element.

Subclasses should, when possible, include all resources that are or may be members of the model element. For instance, a model element should return the same list of resources regardless of the existence of the files on the file system. For example, if a logical resource called "form" maps to "/p1/form.xml" and "/p1/form.java" then whether form.xml or form.java existed, they should be returned by this method.

In some cases, it may not be possible for a model element to know all the resources that may constitute the element without accessing the state of the model element in another location (e.g. a repository). This method is provided with a context which, when provided, gives access to the members of corresponding remote containers and the contents of corresponding remote files. This gives the model element the opportunity to deduce what additional resources should be included in the traversal.

Parameters:
  `context` - gives access to the state of remote resources that correspond to local resources for the purpose of determining traversals that adequately cover the model element resources given the state of the model element in another location. This parameter may be `null`, in which case the implementor can assume that only the local resources are of interest to the client.
  `monitor` - a progress monitor, or `null` if progress reporting is not desired
Returns:
  a set of traversals that cover the resources that constitute the model element
Throws:
  `CoreException` - if the traversals could not be obtained.

### hashCode

public int hashCode()
Override hashCode to use the model object.

Overrides:
  `hashCode` in class `Object`